/*
 * Author:	William Chia-Wei Cheng (william@cs.ucla.edu)
 *
 * Copyright (C) 1990, William Cheng.
 */
#ifndef lint
static char RCSid[] =
      "@(#)$Header: /n/kona/u/tangram/u/william/X11/TGIF/RCS/align.c,v 1.1 90/04/01 22:15:59 william Exp $";
#endif

#include <stdio.h>
#include <X11/Xlib.h>
#include "const.h"
#include "types.h"

#include "drawing.e"	/* RedrawAreas () */
#include "dup.e"	/* justDupped */
#include "grid.e"	/* GridXY () */
#include "mark.e"	/* HighLightForward (), HighLightReverse () */
#include "move.e"	/* MoveObj () */
#include "obj.e"	/* botObj */
#include "select.e"	/* topSel */
#include "setup.e"	/* fileModified */

int	horiAlign = ALIGN_L;
int	vertAlign = ALIGN_T;

void AlignSelObjs ()
{
   register struct SelRec	* sel_ptr;
   register struct ObjRec	* obj_ptr;
   register int			x, y;
   int				pivot_x, pivot_y, dx, dy, ltx, lty, rbx, rby;

   if (topSel == NULL) return;

   HighLightReverse ();

   switch (horiAlign)
   {
      case ALIGN_L : pivot_x = selObjLtX; break;
      case ALIGN_C : pivot_x = (selObjLtX + selObjRbX) / 2; break;
      case ALIGN_R : pivot_x = selObjRbX; break;
   }
   switch (vertAlign)
   {
      case ALIGN_T : pivot_y = selObjLtY; break;
      case ALIGN_M : pivot_y = (selObjLtY + selObjRbY) / 2; break;
      case ALIGN_B : pivot_y = selObjRbY; break;
   }

   for (sel_ptr = topSel; sel_ptr != NULL; sel_ptr = sel_ptr->next)
   {
      obj_ptr = sel_ptr->obj;
      switch (horiAlign)
      {
         case ALIGN_L : x = obj_ptr->obbox.ltx; break;
         case ALIGN_C : x = (obj_ptr->obbox.ltx+obj_ptr->obbox.rbx) / 2; break;
         case ALIGN_R : x = obj_ptr->obbox.rbx; break;
      }
      switch (vertAlign)
      {
         case ALIGN_T : y = obj_ptr->obbox.lty; break;
         case ALIGN_M : y = (obj_ptr->obbox.lty+obj_ptr->obbox.rby) / 2; break;
         case ALIGN_B : y = obj_ptr->obbox.rby; break;
      }
      if (horiAlign == ALIGN_N) x = pivot_x;
      if (vertAlign == ALIGN_N) y = pivot_y;

      dx = pivot_x - x;
      dy = pivot_y - y;

      MoveObj (obj_ptr, dx, dy);
   }
   ltx = selLtX; lty = selLtY; rbx = selRbX, rby = selRbY;
   UpdSelBBox ();
   RedrawAreas (botObj, ltx-(1<<zoomScale), lty-(1<<zoomScale),
         rbx+(1<<zoomScale), rby+(1<<zoomScale), selLtX-(1<<zoomScale),
         selLtY-(1<<zoomScale), selRbX+(1<<zoomScale), selRbY+(1<<zoomScale));
   HighLightForward ();
   fileModified = TRUE;
   justDupped = TRUE;
}

void AlignSelToGrid ()
{
   register struct SelRec	* sel_ptr;
   register struct ObjRec	* obj_ptr;
   register int			x, y;
   int				grid_x, grid_y, dx, dy, ltx, lty, rbx, rby;

   if (topSel == NULL) return;

   HighLightReverse ();

   for (sel_ptr = topSel; sel_ptr != NULL; sel_ptr = sel_ptr->next)
   {
      obj_ptr = sel_ptr->obj;
      switch (horiAlign)
      {
         case ALIGN_L : x = obj_ptr->obbox.ltx; break;
         case ALIGN_C : x = (obj_ptr->obbox.ltx+obj_ptr->obbox.rbx) / 2; break;
         case ALIGN_R : x = obj_ptr->obbox.rbx; break;
      }
      switch (vertAlign)
      {
         case ALIGN_T : y = obj_ptr->obbox.lty; break;
         case ALIGN_M : y = (obj_ptr->obbox.lty+obj_ptr->obbox.rby) / 2; break;
         case ALIGN_B : y = obj_ptr->obbox.rby; break;
      }
      GridXY (x, y, &grid_x, &grid_y);
      if (horiAlign == ALIGN_N) x = grid_x;
      if (vertAlign == ALIGN_N) y = grid_y;

      dx = (grid_x - x) << zoomScale;
      dy = (grid_y - y) << zoomScale;

      MoveObj (obj_ptr, dx, dy);
   }
   ltx = selLtX; lty = selLtY; rbx = selRbX, rby = selRbY;
   UpdSelBBox ();
   RedrawAreas (botObj, ltx-(1<<zoomScale), lty-(1<<zoomScale),
         rbx+(1<<zoomScale), rby+(1<<zoomScale), selLtX-(1<<zoomScale),
         selLtY-(1<<zoomScale), selRbX+(1<<zoomScale), selRbY+(1<<zoomScale));
   HighLightForward ();
   fileModified = TRUE;
   justDupped = TRUE;
}
