/*
 * Author:	William Chia-Wei Cheng (william@cs.ucla.edu)
 *
 * Copyright (C) 1990, William Cheng.
 */
#ifndef lint
static char RCSid[] =
      "@(#)$Header: /n/kona/u/tangram/u/william/X11/TGIF/RCS/font.c,v 1.1 90/04/01 22:16:16 william Exp $";
#endif

#include <X11/Xlib.h>
#include "const.h"
#include "types.h"

#include "choice.e"
#include "color.e"
#include "drawing.e"
#include "mark.e"
#include "menu.e"
#include "obj.e"
#include "pattern.e"
#include "raster.e"
#include "select.e"
#include "setup.e"
#include "text.e"

#define COUR8R  24
#define COUR10R 25
#define COUR12R 26
#define COUR14R 27
#define COUR18R 28
#define COUR24R 29

#define FIndex(FONT,SIZE,STYLE) (SIZE+MAXFONTSIZES*(STYLE+MAXFONTSTYLES*FONT))
#define FONTTABLESIZE (MAXFONTSIZES*MAXFONTSTYLES*MAXFONTS)

struct MyFontRec {
   XFontStruct	* xfs;
   int		valid;
};

XFontStruct	* canvasFontPtr;
int	canvasFontHeight;
int	canvasFontAsc;
int	canvasFontDes;

int	canvasFontIndex;

XFontStruct	* rulerFontPtr;
int	rulerFontWidth;
int	rulerFontHeight;
int	rulerFontAsc;
int	rulerFontDes;

XFontStruct	* defaultFontPtr;
int	defaultFontWidth;
int	defaultFontHeight;
int	defaultFontAsc;
int	defaultFontDes;

int	pointSize[] = { 8, 10, 12, 14, 18, 24 };
int	curFont = FONT_COU;
int	curSize = 4;
int	curStyle = STYLE_NR;
int	curRotate = ROTATE0;

static struct MyFontRec	myFontInfo[FONTTABLESIZE];

static char	* fontMenuStr[] =
{
   "Times", "Courier", "Helvetica", "NewCentury", "Symbol"
};
static char	* sizeMenuStr[] =
{
   "8  #0",
   "10 #1",
   "12 #2",
   "14 #3",
   "18 #4",
   "24 #5"
};
static char	* styleMenuStr[] =
{
   "Roman      ^#O",
   "Bold       ^#B",
   "Italic     ^#T",
   "BoldItalic ^#P",
   "--------------",
   "Left       ^#L",
   "Center     ^#C",
   "Right      ^#R"
};

static char	* fontNameStr[] =
{
   "-adobe-times-medium-r-normal--8-80-75-75-p-44-iso8859-1",
   "-adobe-times-medium-r-normal--10-100-75-75-p-54-iso8859-1",
   "-adobe-times-medium-r-normal--12-120-75-75-p-64-iso8859-1",
   "-adobe-times-medium-r-normal--14-140-75-75-p-74-iso8859-1",
   "-adobe-times-medium-r-normal--18-180-75-75-p-94-iso8859-1",
   "-adobe-times-medium-r-normal--24-240-75-75-p-124-iso8859-1",
   "-adobe-times-bold-r-normal--8-80-75-75-p-47-iso8859-1",
   "-adobe-times-bold-r-normal--10-100-75-75-p-57-iso8859-1",
   "-adobe-times-bold-r-normal--12-120-75-75-p-67-iso8859-1",
   "-adobe-times-bold-r-normal--14-140-75-75-p-77-iso8859-1",
   "-adobe-times-bold-r-normal--18-180-75-75-p-99-iso8859-1",
   "-adobe-times-bold-r-normal--24-240-75-75-p-132-iso8859-1",
   "-adobe-times-medium-i-normal--8-80-75-75-p-42-iso8859-1",
   "-adobe-times-medium-i-normal--10-100-75-75-p-52-iso8859-1",
   "-adobe-times-medium-i-normal--12-120-75-75-p-63-iso8859-1",
   "-adobe-times-medium-i-normal--14-140-75-75-p-73-iso8859-1",
   "-adobe-times-medium-i-normal--18-180-75-75-p-94-iso8859-1",
   "-adobe-times-medium-i-normal--24-240-75-75-p-125-iso8859-1",
   "-adobe-times-bold-i-normal--8-80-75-75-p-47-iso8859-1",
   "-adobe-times-bold-i-normal--10-100-75-75-p-57-iso8859-1",
   "-adobe-times-bold-i-normal--12-120-75-75-p-68-iso8859-1",
   "-adobe-times-bold-i-normal--14-140-75-75-p-77-iso8859-1",
   "-adobe-times-bold-i-normal--18-180-75-75-p-98-iso8859-1",
   "-adobe-times-bold-i-normal--24-240-75-75-p-128-iso8859-1",

   "-adobe-courier-medium-r-normal--8-80-75-75-m-50-iso8859-1",
   "-adobe-courier-medium-r-normal--10-100-75-75-m-60-iso8859-1",
   "-adobe-courier-medium-r-normal--12-120-75-75-m-70-iso8859-1",
   "-adobe-courier-medium-r-normal--14-140-75-75-m-90-iso8859-1",
   "-adobe-courier-medium-r-normal--18-180-75-75-m-110-iso8859-1",
   "-adobe-courier-medium-r-normal--24-240-75-75-m-150-iso8859-1",
   "-adobe-courier-bold-r-normal--8-80-75-75-m-50-iso8859-1",
   "-adobe-courier-bold-r-normal--10-100-75-75-m-60-iso8859-1",
   "-adobe-courier-bold-r-normal--12-120-75-75-m-70-iso8859-1",
   "-adobe-courier-bold-r-normal--14-140-75-75-m-90-iso8859-1",
   "-adobe-courier-bold-r-normal--18-180-75-75-m-110-iso8859-1",
   "-adobe-courier-bold-r-normal--24-240-75-75-m-150-iso8859-1",
   "-adobe-courier-medium-o-normal--8-80-75-75-m-50-iso8859-1",
   "-adobe-courier-medium-o-normal--10-100-75-75-m-60-iso8859-1",
   "-adobe-courier-medium-o-normal--12-120-75-75-m-70-iso8859-1",
   "-adobe-courier-medium-o-normal--14-140-75-75-m-90-iso8859-1",
   "-adobe-courier-medium-o-normal--18-180-75-75-m-110-iso8859-1",
   "-adobe-courier-medium-o-normal--24-240-75-75-m-150-iso8859-1",
   "-adobe-courier-bold-o-normal--8-80-75-75-m-50-iso8859-1",
   "-adobe-courier-bold-o-normal--10-100-75-75-m-60-iso8859-1",
   "-adobe-courier-bold-o-normal--12-120-75-75-m-70-iso8859-1",
   "-adobe-courier-bold-o-normal--14-140-75-75-m-90-iso8859-1",
   "-adobe-courier-bold-o-normal--18-180-75-75-m-110-iso8859-1",
   "-adobe-courier-bold-o-normal--24-240-75-75-m-150-iso8859-1",

   "-adobe-helvetica-medium-r-normal--8-80-75-75-p-46-iso8859-1",
   "-adobe-helvetica-medium-r-normal--10-100-75-75-p-56-iso8859-1",
   "-adobe-helvetica-medium-r-normal--12-120-75-75-p-67-iso8859-1",
   "-adobe-helvetica-medium-r-normal--14-140-75-75-p-77-iso8859-1",
   "-adobe-helvetica-medium-r-normal--18-180-75-75-p-98-iso8859-1",
   "-adobe-helvetica-medium-r-normal--24-240-75-75-p-130-iso8859-1",
   "-adobe-helvetica-bold-r-normal--8-80-75-75-p-50-iso8859-1",
   "-adobe-helvetica-bold-r-normal--10-100-75-75-p-60-iso8859-1",
   "-adobe-helvetica-bold-r-normal--12-120-75-75-p-70-iso8859-1",
   "-adobe-helvetica-bold-r-normal--14-140-75-75-p-82-iso8859-1",
   "-adobe-helvetica-bold-r-normal--18-180-75-75-p-103-iso8859-1",
   "-adobe-helvetica-bold-r-normal--24-240-75-75-p-138-iso8859-1",
   "-adobe-helvetica-medium-o-normal--8-80-75-75-p-47-iso8859-1",
   "-adobe-helvetica-medium-o-normal--10-100-75-75-p-57-iso8859-1",
   "-adobe-helvetica-medium-o-normal--12-120-75-75-p-67-iso8859-1",
   "-adobe-helvetica-medium-o-normal--14-140-75-75-p-78-iso8859-1",
   "-adobe-helvetica-medium-o-normal--18-180-75-75-p-98-iso8859-1",
   "-adobe-helvetica-medium-o-normal--24-240-75-75-p-130-iso8859-1",
   "-adobe-helvetica-bold-o-normal--8-80-75-75-p-50-iso8859-1",
   "-adobe-helvetica-bold-o-normal--10-100-75-75-p-60-iso8859-1",
   "-adobe-helvetica-bold-o-normal--12-120-75-75-p-69-iso8859-1",
   "-adobe-helvetica-bold-o-normal--14-140-75-75-p-82-iso8859-1",
   "-adobe-helvetica-bold-o-normal--18-180-75-75-p-104-iso8859-1",
   "-adobe-helvetica-bold-o-normal--24-240-75-75-p-138-iso8859-1",

   "-adobe-new century schoolbook-medium-r-normal--8-80-75-75-p-50-iso8859-1",
   "-adobe-new century schoolbook-medium-r-normal--10-100-75-75-p-60-iso8859-1",
   "-adobe-new century schoolbook-medium-r-normal--12-120-75-75-p-70-iso8859-1",
   "-adobe-new century schoolbook-medium-r-normal--14-140-75-75-p-82-iso8859-1",
   "-adobe-new century schoolbook-medium-r-normal--18-180-75-75-p-103-iso8859-1",
   "-adobe-new century schoolbook-medium-r-normal--24-240-75-75-p-137-iso8859-1",
   "-adobe-new century schoolbook-bold-r-normal--8-80-75-75-p-56-iso8859-1",
   "-adobe-new century schoolbook-bold-r-normal--10-100-75-75-p-66-iso8859-1",
   "-adobe-new century schoolbook-bold-r-normal--12-120-75-75-p-77-iso8859-1",
   "-adobe-new century schoolbook-bold-r-normal--14-140-75-75-p-87-iso8859-1",
   "-adobe-new century schoolbook-bold-r-normal--18-180-75-75-p-113-iso8859-1",
   "-adobe-new century schoolbook-bold-r-normal--24-240-75-75-p-149-iso8859-1",
   "-adobe-new century schoolbook-medium-i-normal--8-80-75-75-p-50-iso8859-1",
   "-adobe-new century schoolbook-medium-i-normal--10-100-75-75-p-60-iso8859-1",
   "-adobe-new century schoolbook-medium-i-normal--12-120-75-75-p-70-iso8859-1",
   "-adobe-new century schoolbook-medium-i-normal--14-140-75-75-p-81-iso8859-1",
   "-adobe-new century schoolbook-medium-i-normal--18-180-75-75-p-104-iso8859-1",
   "-adobe-new century schoolbook-medium-i-normal--24-240-75-75-p-136-iso8859-1",
   "-adobe-new century schoolbook-bold-i-normal--8-80-75-75-p-56-iso8859-1",
   "-adobe-new century schoolbook-bold-i-normal--10-100-75-75-p-66-iso8859-1",
   "-adobe-new century schoolbook-bold-i-normal--12-120-75-75-p-76-iso8859-1",
   "-adobe-new century schoolbook-bold-i-normal--14-140-75-75-p-88-iso8859-1",
   "-adobe-new century schoolbook-bold-i-normal--18-180-75-75-p-111-iso8859-1",
   "-adobe-new century schoolbook-bold-i-normal--24-240-75-75-p-148-iso8859-1",

   "-adobe-symbol-medium-r-normal--8-80-75-75-p-51-adobe-fontspecific",
   "-adobe-symbol-medium-r-normal--10-100-75-75-p-61-adobe-fontspecific",
   "-adobe-symbol-medium-r-normal--12-120-75-75-p-74-adobe-fontspecific",
   "-adobe-symbol-medium-r-normal--14-140-75-75-p-85-adobe-fontspecific",
   "-adobe-symbol-medium-r-normal--18-180-75-75-p-107-adobe-fontspecific",
   "-adobe-symbol-medium-r-normal--24-240-75-75-p-142-adobe-fontspecific"
};

XFontStruct * GetFontStruct (font_index)
   register int	font_index;
{
   return (myFontInfo[font_index].xfs);
}

int FontIndex (font_index, size_index, style_index)
   register int	font_index, size_index, style_index;
{
   if (font_index == FONT_SYM)
      return (FIndex(font_index,size_index,0));
   else
      return (FIndex(font_index,size_index,style_index));
}

void SetCanvasFont ()
{
   register int	index;

   canvasFontIndex = index = FontIndex (curFont, curSize, curStyle);

   if (!myFontInfo[index].valid)
   {
      if ((myFontInfo[index].xfs =
            XLoadQueryFont (mainDisplay, fontNameStr[index])) == NULL)
      {
         printf ("Can not open %s.  Abort.\n\n", fontNameStr[index]); exit (-1);
      }
      myFontInfo[index].valid = TRUE;
   }

   canvasFontPtr = myFontInfo[index].xfs;
   canvasFontAsc = canvasFontPtr->ascent;
   canvasFontDes = canvasFontPtr->descent;
   canvasFontHeight = canvasFontAsc + canvasFontDes;

   XSetFont (mainDisplay, drawGC, canvasFontPtr->fid);

   textCursorH = canvasFontHeight;
}

void InitFonts ()
{
   register int	i;

   for (i = 0; i < FONTTABLESIZE; i++) myFontInfo[i].valid = FALSE;

   if ((myFontInfo[COUR18R].xfs =
         XLoadQueryFont (mainDisplay, fontNameStr[COUR18R])) == NULL)
   { printf ("Can not open %s.  Abort.\n\n", fontNameStr[COUR18R]); exit (-1); }

   myFontInfo[COUR18R].valid = TRUE;

   if ((myFontInfo[COUR10R].xfs =
         XLoadQueryFont (mainDisplay, fontNameStr[COUR10R])) == NULL)
   { printf ("Can not open %s.  Abort.\n\n", fontNameStr[COUR10R]); exit (-1); }

   myFontInfo[COUR10R].valid = TRUE;

   rulerFontPtr = myFontInfo[COUR10R].xfs;
   rulerFontWidth = rulerFontPtr->max_bounds.width;
   rulerFontAsc = rulerFontPtr->ascent;
   rulerFontDes = rulerFontPtr->descent;
   rulerFontHeight = rulerFontAsc + rulerFontDes;

   defaultFontPtr = myFontInfo[COUR18R].xfs;
   defaultFontWidth = defaultFontPtr->max_bounds.width;
   defaultFontAsc = defaultFontPtr->ascent;
   defaultFontDes = defaultFontPtr->descent;
   defaultFontHeight = defaultFontAsc + defaultFontDes;
}

static
int ChangeObjTextStyle (ObjPtr, StyleIndex)
   register struct ObjRec	* ObjPtr;
   register int			StyleIndex;
{
   register struct ObjRec	* obj_ptr;
   register int			changed = FALSE;

   for (obj_ptr = ObjPtr; obj_ptr != NULL; obj_ptr = obj_ptr->prev)
      switch (obj_ptr->type)
      {
         case OBJ_TEXT:
            if (obj_ptr->detail.t->style != StyleIndex)
            {
               obj_ptr->detail.t->style = StyleIndex;
               UpdTextBBox (obj_ptr);
               changed = TRUE;
            }
            break;

         case OBJ_GROUP:
         case OBJ_SYM:
            if (ChangeObjTextStyle (obj_ptr->detail.r->last, StyleIndex))
            {
               changed = TRUE;
               AdjObjBBox (obj_ptr);
            }
            break;
      }
   return (changed);
}

static
int ChangeObjTextJust (ObjPtr, JustIndex)
   register struct ObjRec	* ObjPtr;
   register int			JustIndex;
{
   register struct ObjRec	* obj_ptr;
   register int			changed = FALSE;

   for (obj_ptr = ObjPtr; obj_ptr != NULL; obj_ptr = obj_ptr->prev)
      switch (obj_ptr->type)
      {
         case OBJ_TEXT:
            if (obj_ptr->detail.t->just != JustIndex)
            {
               obj_ptr->detail.t->just = JustIndex;
               UpdTextBBox (obj_ptr);
               changed = TRUE;
            }
            break;

         case OBJ_GROUP:
         case OBJ_SYM:
            if (ChangeObjTextJust (obj_ptr->detail.r->last, JustIndex))
            {
               changed = TRUE;
               AdjObjBBox (obj_ptr);
            }
            break;
      }
   return (changed);
}

void ChangeFontJust (JustIndex)
   int JustIndex;
{
   register struct SelRec	* sel_ptr;
   register struct ObjRec	* obj_ptr;
   int				ltx, lty, rbx, rby;
   int				text_obj_created, text_cursor_shown;
   int				changed = FALSE;

   if (JustIndex == INVALID) return;

   if (topSel == NULL)
   {
      text_cursor_shown = textCursorShown;
      text_obj_created = TieLooseEnds ();
      textJust = JustIndex;
      ShowJust ();
      if (!text_obj_created && curChoice == DRAWTEXT && text_cursor_shown)
      {
         NewCurText ();
         RedrawCurText ();
      }
      else
         textCursorShown = FALSE;
      return;
   }

   for (sel_ptr = botSel; sel_ptr != NULL; sel_ptr = sel_ptr->prev)
   {
      obj_ptr = sel_ptr->obj;
      switch (obj_ptr->type)
      {
         case OBJ_TEXT:
            if (obj_ptr->detail.t->just != JustIndex)
            {
               obj_ptr->detail.t->just = JustIndex;
               UpdTextBBox (obj_ptr);
               changed = TRUE;
            }
            break;
         case OBJ_GROUP:
         case OBJ_SYM:
            if (ChangeObjTextJust (obj_ptr->detail.r->last, JustIndex))
            {
               changed = TRUE;
               AdjObjBBox (obj_ptr);
            }
            break;
      }
   }

   if (changed)
   {
      HighLightReverse ();
      ltx = selLtX; lty = selLtY; rbx = selRbX; rby = selRbY;
      UpdSelBBox ();
      RedrawAreas (botObj, ltx-(1<<zoomScale), lty-(1<<zoomScale),
            rbx+(1<<zoomScale), rby+(1<<zoomScale), selLtX-(1<<zoomScale),
            selLtY-(1<<zoomScale), selRbX+(1<<zoomScale),
            selRbY+(1<<zoomScale));
      fileModified = TRUE;
      HighLightForward ();
   }
}

void ChangeFontStyle (StyleIndex)
   int	StyleIndex;
{
   register struct SelRec	* sel_ptr;
   register struct ObjRec	* obj_ptr;
   int				ltx, lty, rbx, rby, text_obj_created;
   int				changed = FALSE, text_cursor_shown;

   if (StyleIndex == INVALID) return;

   if (topSel != NULL)
   {
      for (sel_ptr = botSel; sel_ptr != NULL; sel_ptr = sel_ptr->prev)
      {
         obj_ptr = sel_ptr->obj;
         switch (obj_ptr->type)
         {
            case OBJ_TEXT:
               if (obj_ptr->detail.t->style != StyleIndex)
               {
                  obj_ptr->detail.t->style = StyleIndex;
                  UpdTextBBox (obj_ptr);
                  changed = TRUE;
               }
               break;
            case OBJ_GROUP:
            case OBJ_SYM:
               if (ChangeObjTextStyle (obj_ptr->detail.r->last, StyleIndex))
               {
                  changed = TRUE;
                  AdjObjBBox (obj_ptr);
               }
               break;
         }
      }

      if (changed)
      {
         HighLightReverse ();
         ltx = selLtX; lty = selLtY; rbx = selRbX; rby = selRbY;
         UpdSelBBox ();
         RedrawAreas (botObj, ltx-(1<<zoomScale), lty-(1<<zoomScale),
               rbx+(1<<zoomScale), rby+(1<<zoomScale), selLtX-(1<<zoomScale),
               selLtY-(1<<zoomScale), selRbX+(1<<zoomScale),
               selRbY+(1<<zoomScale));
         fileModified = TRUE;
         HighLightForward ();
      }
   }
   else
   {
      text_cursor_shown = textCursorShown;
      text_obj_created = TieLooseEnds ();
      curStyle = StyleIndex;
      SetCanvasFont ();
      if (!text_obj_created && curChoice == DRAWTEXT && text_cursor_shown)
      {
         NewCurText ();
         RedrawCurText ();
      }
      else
         textCursorShown = FALSE;
      ShowCurFont ();
   }
}

void StyleMenu (X, Y)
   int  X, Y;
{
   register int	index;
   int		* fore_colors, * valid;

   DefaultColorArrays (MAXFONTSTYLES+MAXJUSTS+1, &fore_colors, &valid);
   index = TextMenuLoop (X, Y, styleMenuStr, MAXFONTSTYLES+MAXJUSTS+1,
         fore_colors, valid, SINGLECOLOR);

   if (index == INVALID) return;

   if (index < MAXFONTSTYLES)
      ChangeFontStyle (index);
   else if (index > MAXFONTSTYLES)
      ChangeFontJust (index - MAXFONTSTYLES - 1);
}

static
int ChangeObjTextSize (ObjPtr, SizeIndex)
   register struct ObjRec	* ObjPtr;
   register int			SizeIndex;
{
   register struct ObjRec	* obj_ptr;
   register int			changed = FALSE;

   for (obj_ptr = ObjPtr; obj_ptr != NULL; obj_ptr = obj_ptr->prev)
      switch (obj_ptr->type)
      {
         case OBJ_TEXT:
            if (obj_ptr->detail.t->size != SizeIndex)
            {
               obj_ptr->detail.t->size = SizeIndex;
               UpdTextBBox (obj_ptr);
               changed = TRUE;
            }
            break;

         case OBJ_GROUP:
         case OBJ_SYM:
            if (ChangeObjTextSize (obj_ptr->detail.r->last, SizeIndex))
            {
               changed = TRUE;
               AdjObjBBox (obj_ptr);
            }
            break;
      }
   return (changed);
}

void ChangeFontSize (SizeIndex)
   int	SizeIndex;
{
   register struct SelRec	* sel_ptr;
   register struct ObjRec	* obj_ptr;
   int				ltx, lty, rbx, rby, text_obj_created;
   int				text_cursor_shown, changed = FALSE;

   if (SizeIndex == INVALID) return;

   if (topSel != NULL)
   {
      for (sel_ptr = botSel; sel_ptr != NULL; sel_ptr = sel_ptr->prev)
      {
         obj_ptr = sel_ptr->obj;
         switch (obj_ptr->type)
         {
            case OBJ_TEXT:
               if (obj_ptr->detail.t->size != SizeIndex)
               {
                  obj_ptr->detail.t->size = SizeIndex;
                  UpdTextBBox (obj_ptr);
                  changed = TRUE;
               }
               break;
      
            case OBJ_GROUP:
            case OBJ_SYM:
               if (ChangeObjTextSize (obj_ptr->detail.r->last, SizeIndex))
               {
                  changed = TRUE;
                  AdjObjBBox (obj_ptr);
               }
               break;
         }
      }

      if (changed)
      {
         HighLightReverse ();
         ltx = selLtX; lty = selLtY; rbx = selRbX; rby = selRbY;
         UpdSelBBox ();
         RedrawAreas (botObj, ltx-(1<<zoomScale), lty-(1<<zoomScale),
               rbx+(1<<zoomScale), rby+(1<<zoomScale), selLtX-(1<<zoomScale),
               selLtY-(1<<zoomScale), selRbX+(1<<zoomScale),
               selRbY+(1<<zoomScale));
         fileModified = TRUE;
         HighLightForward ();
      }
   }
   else
   {
      text_cursor_shown = textCursorShown;
      text_obj_created = TieLooseEnds ();
      curSize = SizeIndex;
      SetCanvasFont ();
      if (!text_obj_created && curChoice == DRAWTEXT && text_cursor_shown)
      {
         NewCurText ();
         RedrawCurText ();
      }
      else
         textCursorShown = FALSE;
      ShowCurFont ();
   }
}

void SizeMenu (X, Y)
   int  X, Y;
{
   register int			index;
   int				* fore_colors, * valid;

   DefaultColorArrays (MAXFONTSIZES, &fore_colors, &valid);

   index = TextMenuLoop (X, Y, sizeMenuStr, MAXFONTSIZES, fore_colors, valid,
         SINGLECOLOR);
   ChangeFontSize (index);
}

static
int ChangeObjTextFont (ObjPtr, FontIndex)
   register struct ObjRec	* ObjPtr;
   register int			FontIndex;
{
   register struct ObjRec	* obj_ptr;
   register int			changed = FALSE;

   for (obj_ptr = ObjPtr; obj_ptr != NULL; obj_ptr = obj_ptr->prev)
      switch (obj_ptr->type)
      {
         case OBJ_TEXT:
            if (obj_ptr->detail.t->font != FontIndex)
            {
               obj_ptr->detail.t->font = FontIndex;
               UpdTextBBox (obj_ptr);
               changed = TRUE;
            }
            break;

         case OBJ_GROUP:
         case OBJ_SYM:
            if (ChangeObjTextFont (obj_ptr->detail.r->last, FontIndex))
            {
               changed = TRUE;
               AdjObjBBox (obj_ptr);
            }
            break;
      }
   return (changed);
}

ChangeFont (FontIndex)
   int	FontIndex;
{
   register struct SelRec	* sel_ptr;
   register struct ObjRec	* obj_ptr;
   int				changed = FALSE, text_cursor_shown;
   int				ltx, lty, rbx, rby, text_obj_created;

   if (FontIndex == INVALID) return;

   if (topSel != NULL)
   {
      for (sel_ptr = botSel; sel_ptr != NULL; sel_ptr = sel_ptr->prev)
      {
         obj_ptr = sel_ptr->obj;
         switch (obj_ptr->type)
         {
            case OBJ_TEXT:
               if (obj_ptr->detail.t->font != FontIndex)
               {
                  obj_ptr->detail.t->font = FontIndex;
                  UpdTextBBox (obj_ptr);
                  changed = TRUE;
               }
               break;
            case OBJ_GROUP:
            case OBJ_SYM:
               if (ChangeObjTextFont (obj_ptr->detail.r->last, FontIndex))
               {
                  changed = TRUE;
                  AdjObjBBox (obj_ptr);
               }
               break;
         }
      }

      if (changed)
      {
         HighLightReverse ();
         ltx = selLtX; lty = selLtY; rbx = selRbX; rby = selRbY;
         UpdSelBBox ();
         RedrawAreas (botObj, ltx-(1<<zoomScale), lty-(1<<zoomScale),
               rbx+(1<<zoomScale), rby+(1<<zoomScale), selLtX-(1<<zoomScale),
               selLtY-(1<<zoomScale), selRbX+(1<<zoomScale),
               selRbY+(1<<zoomScale));
         fileModified = TRUE;
         HighLightForward ();
      }
   }
   else
   {
      text_cursor_shown = textCursorShown;
      text_obj_created = TieLooseEnds ();
      curFont = FontIndex;
      SetCanvasFont ();
      if (!text_obj_created && curChoice == DRAWTEXT && text_cursor_shown)
      {
         NewCurText ();
         RedrawCurText ();
      }
      else
         textCursorShown = FALSE;
      ShowCurFont ();
   }
}

void FontMenu (X, Y)
   int  X, Y;
{
   register int			index;
   int				* fore_colors, * valid;

   DefaultColorArrays (MAXFONTS, &fore_colors, &valid);
   index = TextMenuLoop (X, Y, fontMenuStr, MAXFONTS, fore_colors, valid,
         SINGLECOLOR);
   ChangeFont (index);
}

static int	savedFont, savedSize, savedStyle;
static int	savedJust, savedRotate, savedPen;

void SaveCurFont ()
{
   savedFont = curFont;
   savedSize = curSize;
   savedStyle = curStyle;
   savedJust = textJust;
   savedRotate = curRotate;
   savedPen = penPat;
}

void RestoreCurFont ()
{
   curFont = savedFont;
   curSize = savedSize;
   curStyle = savedStyle;
   textJust = savedJust;
   curRotate = savedRotate;
   penPat = savedPen;

   SetCanvasFont ();
}

static int	pushedFont, pushedSize, pushedStyle, pushedJust;
static int	pushedColorIndex, pushedRotate, pushedPen;

void PushCurFont ()
{
   pushedFont = curFont;
   pushedSize = curSize;
   pushedStyle = curStyle;
   pushedJust = textJust;
   pushedRotate = curRotate;
   pushedPen = penPat;
   pushedColorIndex = colorIndex;
}

void PopCurFont ()
{
   curFont = pushedFont;
   curSize = pushedSize;
   curStyle = pushedStyle;
   textJust = pushedJust;
   curRotate = pushedRotate;
   penPat = pushedPen;
   colorIndex = pushedColorIndex;

   SetCanvasFont ();
}

void CleanUpFonts ()
{
   register int	i;

   for (i = 0; i < FONTTABLESIZE; i++)
      if (myFontInfo[i].valid)
      {
         XFreeFont (mainDisplay, myFontInfo[i].xfs);
         myFontInfo[i].valid = FALSE;
      }
}
