/*
 * Author:	William Chia-Wei Cheng (william@cs.ucla.edu)
 *
 * Copyright (C) 1990, William Cheng.
 */
#ifndef lint
static char RCSid[] =
      "@(#)$Header: /n/kona/u/tangram/u/william/X11/TGIF/RCS/msg.c,v 1.1 90/04/01 22:16:25 william Exp $";
#endif

#include <stdio.h>
#include <X11/Xlib.h>
#include "const.h"
#include "types.h"

#include "font.e"
#include "raster.e"
#include "setup.e"

static char	oneLineMsg = TRUE;
static char	lastMsg1[256], lastMsg2[256];

void RedrawMsg ()
{
   int		max_char_per_line, x, y;
   char		s[255], * c_ptr;
   XEvent       ev;

   XSync (mainDisplay, FALSE);
   while (XCheckWindowEvent (mainDisplay, msgWindow, ExposureMask, &ev)) ;

   x = 2;
   y = 2 + defaultFontAsc;

   if (oneLineMsg)
   {
      max_char_per_line = msgWindowW / defaultFontWidth;
      if (strlen (lastMsg1) > max_char_per_line)
      {
         strcpy (s, lastMsg1);
         c_ptr = &s[max_char_per_line];
         while (c_ptr != s && *c_ptr != ' ') c_ptr--;

         if (c_ptr != s)
         {
            *c_ptr++ = '\0';
            XDrawString (mainDisplay, msgWindow, defaultGC, x, y, s, strlen(s));
            XDrawString (mainDisplay, msgWindow, defaultGC, x,
                  y+defaultFontHeight, c_ptr, strlen(c_ptr));
         }
         else
            XDrawString (mainDisplay, msgWindow, defaultGC, x,
                  y, lastMsg1, strlen(lastMsg1));
      }
      else
         XDrawString (mainDisplay, msgWindow, defaultGC, x,
               y, lastMsg1, strlen(lastMsg1));
   }
   else
   {
      XDrawString (mainDisplay, msgWindow, defaultGC, x, y, lastMsg1,
            strlen(lastMsg1));
      XDrawString (mainDisplay, msgWindow, defaultGC, x, y+defaultFontHeight,
            lastMsg2, strlen(lastMsg2));
   }
   XSync (mainDisplay, FALSE);
}

void Msg (Message)
   char	* Message;
{
   XClearWindow (mainDisplay, msgWindow);
   strcpy (lastMsg1, Message);
   strcpy (lastMsg2, "");
   oneLineMsg = TRUE;
   RedrawMsg ();
}

void TwoLineMsg (Msg1, Msg2)
   char	* Msg1, * Msg2;
{
   XClearWindow (mainDisplay, msgWindow);
   strcpy (lastMsg1, Msg1);
   strcpy (lastMsg2, Msg2);
   oneLineMsg = FALSE;
   RedrawMsg ();
}
