/*
 * Author:	William Chia-Wei Cheng (william@cs.ucla.edu)
 *
 * Copyright (C) 1990, William Cheng.
 */
#ifndef lint
static char RCSid[] =
      "@(#)$Header: /n/kona/u/tangram/u/william/X11/TGIF/RCS/prtgif.c,v 1.1 90/05/02 08:23:04 william Exp $";
#endif

#include <stdio.h>
#include <X11/Xlib.h>
#include "const.h"
#include "types.h"

#include "attr.e"
#include "box.e"
#include "file.e"
#include "font.e"
#include "grid.e"
#include "group.e"
#include "obj.e"
#include "oval.e"
#include "pattern.e"
#include "poly.e"
#include "polygon.e"
#include "setup.e"
#include "text.e"

extern char	* getenv ();
/* extern int	malloc_debug (); */
extern int	PDrawReadObj ();

static char	drawPath[256];
static short	pDrawCursorH[] =
{
   9,  11, 13, 14, 19, 26,
   9,  11, 14, 14, 19, 26,
   9,  11, 13, 14, 19, 25,
   9,  12, 13, 15, 19, 25,
   8,  10, 13, 14, 17, 22,
   10, 10, 13, 15, 18, 23,
   10, 10, 13, 14, 17, 22,
   10, 10, 13, 15, 17, 28,
   9,  12, 14, 16, 20, 27,
   9,  12, 14, 16, 21, 27,
   9,  12, 14, 16, 21, 27,
   9,  12, 14, 16, 21, 27,
   9,  11, 14, 16, 20, 26,
   9,  11, 14, 16, 20, 26,
   9,  11, 14, 16, 24, 26,
   9,  11, 14, 16, 20, 26,
   11, 10, 12, 14, 18, 24
};
static short	pDrawFontAsc[] =
{
   7, 8,  10, 11, 15, 20,
   7, 8,  11, 11, 15, 20,
   7, 8,  10, 11, 15, 20,
   7, 9,  10, 12, 15, 20,
   6, 8,  10, 11, 13, 17,
   8, 8,  10, 11, 13, 18,
   8, 8,  10, 11, 13, 17,
   8, 8,  10, 11, 13, 23,
   7, 10, 11, 13, 16, 22,
   7, 10, 11, 13, 16, 22,
   7, 10, 11, 13, 16, 22,
   7, 10, 11, 13, 16, 22,
   7, 9,  11, 13, 16, 21,
   7, 9,  11, 13, 16, 21,
   7, 9,  11, 13, 18, 21,
   7, 9,  11, 13, 18, 21,
   8, 8,  9,  11, 14, 19
};
static short	pDrawFontDes[] =
{
   2, 3, 3, 3, 4, 6,
   2, 3, 3, 3, 4, 6,
   2, 3, 3, 3, 4, 5,
   2, 3, 3, 3, 4, 5,
   2, 2, 3, 3, 4, 5,
   2, 2, 3, 4, 5, 5,
   2, 2, 3, 3, 4, 5,
   2, 2, 3, 4, 4, 5,
   2, 2, 3, 3, 4, 5,
   2, 2, 3, 3, 5, 5,
   2, 2, 3, 3, 5, 5,
   2, 2, 3, 3, 5, 5,
   2, 2, 3, 3, 4, 5,
   2, 2, 3, 3, 4, 5,
   2, 2, 3, 3, 6, 5,
   2, 2, 3, 3, 6, 5,
   3, 2, 3, 3, 4, 5
};

static
void PDrawDumpTextObj (FP, ObjPtr)
   FILE				* FP;
   register struct ObjRec	* ObjPtr;
{
   int			x, y, font_size, xinc, yinc;
   struct StrRec	* s_ptr;
   struct TextRec	* text_ptr = ObjPtr->detail.t;

   if (text_ptr->pen == NONEPAT) return;

   curFont = text_ptr->font;
   curStyle = text_ptr->style;
   curSize = text_ptr->size;
   textJust = text_ptr->just;
   curRotate = text_ptr->rotate;
   penPat = text_ptr->pen;
   textCursorH = pDrawCursorH[FontIndex(curFont,curSize,curStyle)];
   canvasFontAsc = pDrawFontAsc[FontIndex(curFont,curSize,curStyle)];
   canvasFontDes = pDrawFontDes[FontIndex(curFont,curSize,curStyle)];

   x = ObjPtr->x;
   y = ObjPtr->y;

   if (curFont == FONT_SYM)
   {
      fprintf (FP, "/Symbol ");
      font_size = pointSize[curSize];
      fprintf (FP, "findfont [%1d 0 0 -%1d 0 %1d] makefont setfont\n",
            font_size, font_size, font_size);
   }
   else
   {
      switch (curFont)
      {
         case FONT_TIM: fprintf (FP, "/Times"); break;
         case FONT_COU: fprintf (FP, "/Courier"); break;
         case FONT_HEL: fprintf (FP, "/Helvetica"); break;
         case FONT_CEN: fprintf (FP, "/NewCenturySchlbk"); break;
      }
      switch (curStyle)
      {
         case STYLE_BI:
            switch (curFont)
            {
               case FONT_TIM: fprintf (FP, "-BoldItalic "); break;
               case FONT_COU: fprintf (FP, "-BoldOblique "); break;
               case FONT_HEL: fprintf (FP, "-BoldOblique "); break;
               case FONT_CEN: fprintf (FP, "-BoldItalic "); break;
            }
            break;
         case STYLE_BR: fprintf (FP, "-Bold "); break;
         case STYLE_NI:
            switch (curFont)
            {
               case FONT_TIM: fprintf (FP, "-Italic "); break;
               case FONT_COU: fprintf (FP, "-Oblique "); break;
               case FONT_HEL: fprintf (FP, "-Oblique "); break;
               case FONT_CEN: fprintf (FP, "-Italic "); break;
            }
            break;
         case STYLE_NR:
            switch (curFont)
            {
               case FONT_TIM: fprintf (FP, "-Roman "); break;
               case FONT_COU: fprintf (FP, " "); break;
               case FONT_HEL: fprintf (FP, " "); break;
               case FONT_CEN: fprintf (FP, "-Roman "); break;
            }
            break;
      }
      font_size = pointSize[curSize];
      fprintf (FP, "findfont [%1d 0 0 -%1d 0 %1d] makefont setfont\n",
            font_size, font_size, font_size);
   }

   switch (penPat)
   {
      case SOLIDPAT: fprintf (FP, "   0 setgray\n"); break;
      case BACKPAT: fprintf (FP, "   1 setgray\n"); break;
      default:
         fprintf (FP, "   pat%1d 8 1 0 72 300 32 div div setpattern\n", penPat);
         break;
   }

   switch (curRotate)
   {
      case ROTATE0: xinc = 0; yinc = textCursorH; break;
      case ROTATE90: xinc = -textCursorH; yinc = 0; break;
      case ROTATE180: xinc = 0; yinc = -textCursorH; break;
      case ROTATE270: xinc = textCursorH; yinc = 0; break;
   }

   for (s_ptr = text_ptr->first; s_ptr != NULL; s_ptr = s_ptr->next)
   {
      switch (curRotate)
      {
         case ROTATE0:
            fprintf (FP, "   %1d %1d moveto (", x, y-canvasFontDes);
            break;
         case ROTATE90:
            fprintf (FP, "   %1d %1d moveto 90 rotate (", x+canvasFontDes, y);
            break;
         case ROTATE180:
            fprintf (FP, "   %1d %1d moveto 180 rotate (", x, y+canvasFontDes);
            break;
         case ROTATE270:
            fprintf (FP, "   %1d %1d moveto 270 rotate (", x-canvasFontDes, y);
            break;
      }
      DumpOneStr (FP, s_ptr->s);
      switch (textJust)
      {
         case JUST_L: fprintf (FP, ") show"); break;
         case JUST_C: fprintf (FP, ") centertext"); break;
         case JUST_R: fprintf (FP, ") righttext"); break;
      }
      switch (curRotate)
      {
         case ROTATE0: fprintf (FP, "\n"); break;
         case ROTATE90: fprintf (FP, " -90 rotate \n"); break;
         case ROTATE180: fprintf (FP, " -180 rotate \n"); break;
         case ROTATE270: fprintf (FP, " -270 rotate \n"); break;
      }
      x += xinc;
      y += yinc;
   }
   fprintf (FP, "\n");
   fprintf (FP, "   0 setgray\n");
}

static
void PDrawDumpAttrs (FP, AttrPtr)
   FILE				* FP;
   register struct AttrRec	* AttrPtr;
{
   for ( ; AttrPtr != NULL; AttrPtr = AttrPtr->prev)
      if (AttrPtr->shown)
         PDrawDumpTextObj (FP, AttrPtr->obj);
}

static
void PDrawDumpAllObj (FP, ObjPtr)
   FILE				* FP;
   register struct ObjRec	* ObjPtr;
{
   register struct ObjRec	* obj_ptr;

   switch (ObjPtr->type)
   {
      case OBJ_POLY:
         DumpPolyObj (FP, ObjPtr);
         PDrawDumpAttrs (FP, ObjPtr->detail.p->lattr);
         break;
      case OBJ_BOX: DumpBoxObj (FP, ObjPtr); break;
      case OBJ_OVAL: DumpOvalObj (FP, ObjPtr); break;
      case OBJ_TEXT: PDrawDumpTextObj (FP, ObjPtr); break;
      case OBJ_POLYGON: DumpPolygonObj (FP, ObjPtr); break;
      case OBJ_SYM:
      case OBJ_ICON:
      case OBJ_GROUP:
         obj_ptr = ObjPtr->detail.r->last;
         for ( ; obj_ptr != NULL; obj_ptr = obj_ptr->prev)
            PDrawDumpAllObj (FP, obj_ptr);
         PDrawDumpAttrs (FP, ObjPtr->detail.r->lattr);
         if (ObjPtr->type == OBJ_SYM) DumpSymOutline (FP, ObjPtr);
         break;
   }
}

static struct StrRec	* pDrawFirstStr = NULL, * pDrawLastStr = NULL;

static
void PDrawAddStr (PrevPtr, NextPtr, StrPtr)
   struct StrRec	* PrevPtr, * NextPtr, * StrPtr;
{
   StrPtr->prev = PrevPtr;
   StrPtr->next = NextPtr;

   if (PrevPtr == NULL)
      pDrawFirstStr = StrPtr;
   else
      PrevPtr->next = StrPtr;

   if (NextPtr == NULL)
      pDrawLastStr = StrPtr;
   else
      NextPtr->prev = StrPtr;
}

static
void PDrawReadTextObj (FP, Inbuf, ObjPtr)
   FILE			* FP;
   char			* Inbuf;
   struct ObjRec	* * ObjPtr;
{
   register int		i;
   struct StrRec	* s_ptr;
   struct TextRec	* text_ptr;
   char			color_str[20], * s, tmp_str[80], inbuf[255];
   int			num_lines, x, y, font, style, size;
   int			text_just, rotate, pen;

   * ObjPtr = (struct ObjRec *) calloc (1, sizeof(struct ObjRec));
   s = FindChar ('(', Inbuf);
   s = ParseStr (s, ',', color_str);
   if (fileVersion <= 2)
   {
      sscanf (s, "%d , %d , %d , %d , %d , %d , %d", &x, &y, &font, &style,
            &size, &num_lines, &text_just);
      rotate = 0;
      pen = 1;
   }
   else
      sscanf (s, "%d , %d , %d , %d , %d , %d , %d , %d , %d", &x, &y, &font,
            &style, &size, &num_lines, &text_just, &rotate, &pen);

   text_ptr = (struct TextRec *) calloc (1, sizeof(struct TextRec));
   text_ptr->just = text_just;
   text_ptr->lines = num_lines;
   text_ptr->rotate = rotate;
   text_ptr->pen = pen;

   curFont = text_ptr->font = font;
   curStyle = text_ptr->style = style;
   curSize = text_ptr->size = size;
   textJust = text_just;
   curRotate = rotate;
   penPat = pen;
   textCursorH = pDrawCursorH[FontIndex(curFont,curSize,curStyle)];
   canvasFontAsc = pDrawFontAsc[FontIndex(curFont,curSize,curStyle)];

   for (i = 0; i < num_lines; i++)
   {
      fgets (inbuf, 255, FP);
      strcpy(tmp_str, FindChar ('"', inbuf));
      s = FindChar ('"', tmp_str);
      *(--s) = '\0';
      s_ptr = (struct StrRec *) calloc (1, sizeof(struct StrRec));
      strcpy (s_ptr->s, tmp_str);
      PDrawAddStr (pDrawLastStr, NULL, s_ptr);
   }
   text_ptr->first = pDrawFirstStr;
   text_ptr->last = pDrawLastStr;

   pDrawFirstStr = pDrawLastStr = NULL;

   (*ObjPtr)->x = x;
   (*ObjPtr)->y = y;
   (*ObjPtr)->type = OBJ_TEXT;
   (*ObjPtr)->color = FindColorIndex (color_str);
   (*ObjPtr)->detail.t = text_ptr;
}

static
void PDrawReadState (Inbuf)
   char	* Inbuf;
{
   char	* s;

   s = FindChar ('(', Inbuf);
   sscanf (s, "%d", &pageStyle);
   s = FindChar (',', s);
   if (*s == '\0')
      fileVersion = INVALID;
   else
      sscanf (s, "%d", &fileVersion);
}

static
void PDrawReadGroupObj (FP, ObjPtr)
   FILE			* FP;
   struct ObjRec	* * ObjPtr;
{
   struct GroupRec	* group_ptr;
   struct ObjRec	* top_obj = NULL, * bot_obj = NULL, * obj_ptr;
   int			ltx, lty, rbx, rby;
   int			obj_ltx, obj_lty, obj_rbx, obj_rby;

   * ObjPtr = (struct ObjRec *) calloc (1, sizeof(struct ObjRec));

   while (PDrawReadObj (FP, &obj_ptr))
   {
      obj_ptr->next = top_obj;
      if (top_obj == NULL)
         bot_obj = obj_ptr;
      else
         top_obj->prev = obj_ptr;
      top_obj = obj_ptr;
   }
   top_obj->prev = NULL;

   group_ptr = (struct GroupRec *) calloc (1, sizeof(struct GroupRec));
   group_ptr->first = top_obj;
   group_ptr->last = bot_obj;

   ltx = top_obj->bbox.ltx;
   lty = top_obj->bbox.lty;
   rbx = top_obj->bbox.rbx;
   rby = top_obj->bbox.rby;
   obj_ltx = top_obj->obbox.ltx;
   obj_lty = top_obj->obbox.lty;
   obj_rbx = top_obj->obbox.rbx;
   obj_rby = top_obj->obbox.rby;
   for (obj_ptr = top_obj->next; obj_ptr != NULL; obj_ptr = obj_ptr->next)
   {
      if (obj_ptr->bbox.ltx < ltx) ltx = obj_ptr->bbox.ltx;
      if (obj_ptr->bbox.lty < lty) lty = obj_ptr->bbox.lty;
      if (obj_ptr->bbox.rbx > rbx) rbx = obj_ptr->bbox.rbx;
      if (obj_ptr->bbox.rby > rby) rby = obj_ptr->bbox.rby;
      if (obj_ptr->obbox.ltx < obj_ltx) obj_ltx = obj_ptr->obbox.ltx;
      if (obj_ptr->obbox.lty < obj_lty) obj_lty = obj_ptr->obbox.lty;
      if (obj_ptr->obbox.rbx > obj_rbx) obj_rbx = obj_ptr->obbox.rbx;
      if (obj_ptr->obbox.rby > obj_rby) obj_rby = obj_ptr->obbox.rby;
   }
   
   (*ObjPtr)->x = obj_ltx;
   (*ObjPtr)->y = obj_lty;
   (*ObjPtr)->type = OBJ_GROUP;
   (*ObjPtr)->bbox.ltx = ltx;
   (*ObjPtr)->bbox.lty = lty;
   (*ObjPtr)->bbox.rbx = rbx;
   (*ObjPtr)->bbox.rby = rby;
   (*ObjPtr)->obbox.ltx = obj_ltx;
   (*ObjPtr)->obbox.lty = obj_lty;
   (*ObjPtr)->obbox.rbx = obj_rbx;
   (*ObjPtr)->obbox.rby = obj_rby;
   (*ObjPtr)->detail.r = group_ptr;
}

static
int  PDrawReadAttr (FP, AttrPtr)
   FILE			* FP;
   struct AttrRec	* * AttrPtr;
{
   struct ObjRec	* TextObj;
   char			inbuf[255], * s, name[80], value[80];
   int			len, shown, nameshown, inherited;
 
   fgets (inbuf, 255, FP); 

   if (inbuf[0] == ']')  return (FALSE);

   *AttrPtr = (struct AttrRec *)  calloc (1, sizeof(struct AttrRec)); 

   len = strlen(inbuf) - 1;
   inbuf[len] = '\0';

   strcpy(name, FindChar ('"', inbuf));
   s = FindChar ('"', inbuf);
   s = FindChar (',', s);
   strcpy(value, FindChar ('"', s));
   s = FindChar ('"', value);
   s = FindChar (',', s);
   sscanf (s, "%d, %d, %d", &shown, &nameshown, &inherited);

   s = FindChar ('"', name);
   *(--s) = '\0';
   strcpy ((*AttrPtr)->name, name);
   s = FindChar ('"', value);
   *(--s) = '\0';
   strcpy ((*AttrPtr)->s, value);

   (*AttrPtr)->shown = shown;
   (*AttrPtr)->nameshown = nameshown;
   (*AttrPtr)->inherited = inherited;

   PDrawReadObj (FP, &TextObj);
   TextObj->detail.t->attr = *AttrPtr;
   (*AttrPtr)->obj = TextObj;

   return (TRUE);
}

int PDrawReadObj (FP, ObjPtr)
   FILE			* FP;
   struct ObjRec	* * ObjPtr;
{
   char			inbuf[255], obj_name[10], tmp_str[80], * s, * s1;
   int			len, id;
   struct AttrRec       * top_attr = NULL, * bot_attr = NULL, * attr_ptr;

   while (fgets (inbuf, 255, FP) != NULL)
   {
      if (inbuf[0] == ']') return (FALSE);

      len = strlen(inbuf)-1;
      inbuf[len] = '\0';
      ParseStr (inbuf, '(', obj_name);
      if (strcmp (obj_name, "poly") == 0)
      {
         ReadPolyObj (inbuf, ObjPtr);
         if (fileVersion != INVALID)
            while (PDrawReadAttr (FP, &attr_ptr))
            {
               attr_ptr->owner = *ObjPtr;
               attr_ptr->prev = NULL;
               attr_ptr->next = top_attr;
               if (top_attr == NULL)
                  bot_attr = attr_ptr;
               else
                  top_attr->prev = attr_ptr;
               top_attr = attr_ptr;
            }
         if (bot_attr != NULL) bot_attr->next = NULL;
         (*ObjPtr)->detail.p->fattr = top_attr;
         (*ObjPtr)->detail.p->lattr = bot_attr;
         AdjObjBBox (*ObjPtr);
         return (TRUE);
      }
      else if (strcmp (obj_name, "box") == 0)
      {
         ReadBoxObj (inbuf, ObjPtr);
         return (TRUE);
      }
      else if (strcmp (obj_name, "oval") == 0)
      {
         ReadOvalObj (inbuf, ObjPtr);
         return (TRUE);
      }
      else if (strcmp (obj_name, "text") == 0)
      {
         PDrawReadTextObj (FP, inbuf, ObjPtr);
         return (TRUE);
      }
      else if (strcmp (obj_name, "polygon") == 0)
      {
         ReadPolygonObj (inbuf, ObjPtr);
         return (TRUE);
      }
      else if (strcmp (obj_name, "group") == 0)
      {
         PDrawReadGroupObj (FP, ObjPtr);
         if (fileVersion != INVALID)
            while (PDrawReadAttr (FP, &attr_ptr))
            {
               attr_ptr->owner = *ObjPtr;
               attr_ptr->prev = NULL;
               attr_ptr->next = top_attr;
               if (top_attr == NULL)
                  bot_attr = attr_ptr;
               else
                  top_attr->prev = attr_ptr;
               top_attr = attr_ptr;
            }
         if (bot_attr != NULL) bot_attr->next = NULL;
         (*ObjPtr)->detail.r->fattr = top_attr;
         (*ObjPtr)->detail.r->lattr = bot_attr;
         AdjObjBBox (*ObjPtr);
         return (TRUE);
      }
      else if (strcmp (obj_name, "sym") == 0)
      {
         PDrawReadGroupObj (FP, ObjPtr);
         (*ObjPtr)->type = OBJ_SYM;
         if (fileVersion != INVALID)
            while (PDrawReadAttr (FP, &attr_ptr))
            {
               attr_ptr->owner = *ObjPtr;
               attr_ptr->prev = NULL;
               attr_ptr->next = top_attr;
               if (top_attr == NULL)
                  bot_attr = attr_ptr;
               else
                  top_attr->prev = attr_ptr;
               top_attr = attr_ptr;
            }
         if (bot_attr != NULL) bot_attr->next = NULL;
         (*ObjPtr)->detail.r->fattr = top_attr;
         (*ObjPtr)->detail.r->lattr = bot_attr;
         AdjObjBBox (*ObjPtr);
         return (TRUE);
      }
      else if (strcmp (obj_name, "icon") == 0)
      {
         PDrawReadGroupObj (FP, ObjPtr);
         (*ObjPtr)->type = OBJ_ICON;
         if (fgets (inbuf, 255, FP) == NULL) return (FALSE);

         strcpy(tmp_str, FindChar ('"', inbuf));
         s = FindChar ('"', tmp_str);
         if (fileVersion != INVALID)
         {
            s1 = FindChar (',', s);
            sscanf (s1, "%d", &id);
            if (id >= objId) objId = id+1;
            (*ObjPtr)->detail.r->id = id;
         }
         (*ObjPtr)->detail.r->dirty = FALSE;
         *(--s) = '\0';
         strcpy ((*ObjPtr)->detail.r->s, tmp_str);
         if (fileVersion != INVALID)
            while (PDrawReadAttr (FP, &attr_ptr))
            {
               attr_ptr->owner = *ObjPtr;
               attr_ptr->prev = NULL;
               attr_ptr->next = top_attr;
               if (top_attr == NULL)
                  bot_attr = attr_ptr;
               else
                  top_attr->prev = attr_ptr;
               top_attr = attr_ptr;
            }
         if (bot_attr != NULL) bot_attr->next = NULL;
         (*ObjPtr)->detail.r->fattr = top_attr;
         (*ObjPtr)->detail.r->lattr = bot_attr;
         AdjObjBBox (*ObjPtr);
         return (TRUE);
      }
      else if (strcmp (obj_name, "state") == 0)
      {
         PDrawReadState (inbuf);
         *ObjPtr = NULL;
         return (TRUE);
      }
   }
   return (FALSE);
}

static
void PDrawLoad (FileName)
   char	* FileName;
{
   struct ObjRec	* obj_ptr;
   char 		full_name[MAXPATHLENGTH];
   FILE			* fp;

   strcpy (full_name, FileName);
   strcat (full_name, ".obj");

   if ((fp = fopen (full_name, "r")) == NULL)
   {
      printf ("Can not open '%s'.", full_name);
      return;
   }

   printf ("Reading '%s' ...\n", full_name);

   while (PDrawReadObj (fp, &obj_ptr))
      if (obj_ptr != NULL)
         AddObj (NULL, topObj, obj_ptr);

   fclose (fp);
}

static
void PDrawDump ()
{
   register struct ObjRec	* obj_ptr;
   char				cmd[256];
   FILE				* fp;

   if (botObj == NULL) { printf ("No object to print."); return; }

   system ("rm -f /tmp/DRAW.PS /tmp/DUMP.PS");
   if ((fp = fopen ("/tmp/DUMP.PS", "w")) == NULL)
   {
      Msg ("Can not create /tmp/DUMP.PS, print aborted.");
      return;
   }

   printf ("Writing to /tmp/DRAW.PS ...\n");

   for (obj_ptr = botObj; obj_ptr != NULL; obj_ptr = obj_ptr->prev)
      PDrawDumpAllObj (fp, obj_ptr);

   fprintf (fp, "grestore\n\n");
   fprintf (fp, "showpage\n");
   fclose (fp);

   switch (pageStyle)
   {
      case PORTRAIT:
         sprintf (cmd, "cat %s/.psmac %s/.port /tmp/DUMP.PS > /tmp/DRAW.PS",
               drawPath, drawPath);
         break;
      case LANDSCAPE:
         sprintf (cmd, "cat %s/.psmac %s/.land /tmp/DUMP.PS > /tmp/DRAW.PS",
               drawPath, drawPath);
         break;
      case HIGHPORT:
         sprintf (cmd, "cat %s/.psmac %s/.hiport /tmp/DUMP.PS > /tmp/DRAW.PS",
               drawPath, drawPath);
         break;
      case HIGHLAND:
         sprintf (cmd, "cat %s/.psmac %s/.hiland /tmp/DUMP.PS > /tmp/DRAW.PS",
               drawPath, drawPath);
         break;
      case SLIDEPORT:
         sprintf (cmd, "cat %s/.psmac %s/.slideport /tmp/DUMP.PS > /tmp/DRAW.PS",
               drawPath, drawPath);
         break;
      case SLIDELAND:
         sprintf (cmd, "cat %s/.psmac %s/.slideland /tmp/DUMP.PS > /tmp/DRAW.PS",
               drawPath, drawPath);
         break;
   }
   system (cmd);
   chmod ("/tmp/DRAW.PS", 0777);
   chmod ("/tmp/DUMP.PS", 0777);
   system ("lpr /tmp/DRAW.PS");

   printf ("/tmp/DRAW.PS printed.\n\n");
}

main (argc, argv)
   int	argc;
   char	* argv[];
{
   char	inbuf[256];
   char	* c_ptr;

/* malloc_debug (1); */

   if ((c_ptr = getenv ("TGIFPATH")) == NULL)
      strcpy (drawPath, "/u/tangram/u/william/X11/TGIF");
   else
      if (strlen (c_ptr) >= 255)
         /* must be an error */
         strcpy (drawPath, "/u/tangram/u/william/X11/TGIF");
      else
         strcpy (drawPath, c_ptr);

   switch (argc)
   {
      case 1:
         printf ("\nDraw File Name to Print> ");
         while (fgets (inbuf, 255, stdin) != NULL)
         {
            PDrawLoad (inbuf);
            PDrawDump ();
            printf ("\nDraw File Name to Print> ");
         }
         break;
      default:
         for (argc--, argv++; argc > 0; argc--, argv++)
         {
            PDrawLoad (*argv);
            PDrawDump ();
            DelAllObj ();
         }
   }
}
