/*
 * Author:	William Chia-Wei Cheng (william@cs.ucla.edu)
 *
 * Copyright (C) 1990, William Cheng.
 */
#ifndef lint
static char RCSid[] =
      "@(#)$Header: /n/kona/u/tangram/u/william/X11/TGIF/RCS/tgif.c,v 1.4 90/05/17 08:23:08 william Exp $";
#endif

#include <stdio.h>
#include <X11/Xlib.h>
#include "const.h"
#include "types.h"

#include "mainloop.e"
#include "setup.e"
#include "version.e"

/* extern int	malloc_debug (); */

static
void Prompt2 (PromptStr, OpName, FileName)
   char	* PromptStr, * OpName, * FileName;
{
   char	inbuf[80];

   printf (PromptStr);
   fgets (inbuf, 80, stdin);
   sscanf (inbuf, "%s%s", OpName, FileName);
}

static
void Prompt3 (PromptStr, AttrName, ColorName, ValName)
   char	* PromptStr, * AttrName, * ColorName, * ValName;
{
   char	inbuf[80];

   printf (PromptStr);
   fgets (inbuf, 80, stdin);
   sscanf (inbuf, "%s%s%s", AttrName, ColorName, ValName);
}

int main (argc, argv)
   int	argc;
   char	* argv[];
   /* All these strangeness with strings are related to */
   /*	Prolog's foreign function interface. */
{
   int	i;
   char	op_name[80], file_name[80], s[80], color_name[80], val_name[80];
   char	* sp[6], * func_strp, attr_name[80], speed_name[80], type_name[80];
   char	* c_ptr, id_name[80];

   file_name[0] = '\0';
   for (i = 1; i < argc; i++)
   {
      if (*argv[i] == '=')
      {
         strcpy (geometrySpec, argv[i]);
         geometrySpecified = TRUE;
      }
      else if (*argv[i] != '-')
         strcpy (file_name, argv[i]);
   }

/* malloc_debug (1); */

   sprintf (initMsg1, "%s Version %s", TOOL_NAME, version_string);
   sprintf (initMsg2, "Copyright (C) 1990, William Chia-Wei Cheng");
   printf ("%s\n", initMsg1);
   printf ("%s\n", initMsg2);

   if (file_name[0] == '\0')
      MainLoop ("init", "", &func_strp,
            &sp[0], &sp[1], &sp[2], &sp[3], &sp[4], &sp[5]);
   else
      MainLoop ("init", file_name, &func_strp,
            &sp[0], &sp[1], &sp[2], &sp[3], &sp[4], &sp[5]);
/* for (i = 0; i < 6; i++) */
/*    if (strcmp (sp[i], "") != 0) */
/*       printf ("%s ", sp[i]); */
/*    else */
/*       break; */
/* printf ("\n"); */

   while (TRUE)
   {
      DeallocStrings (&func_strp,&sp[0],&sp[1],&sp[2],&sp[3],&sp[4],&sp[5]);

      strcpy (s, func_strp);
      s[4] = '\0';
      if (strcmp (s, "Quit") == 0)
      {
         MainLoop ("quit", file_name, &func_strp,
               &sp[0], &sp[1], &sp[2], &sp[3], &sp[4], &sp[5]);
         break;
      }

      Prompt2 ("Input an operation and a sub command.\n",op_name,file_name);

      if (strcmp (op_name, "animate") == 0)
      {
         Prompt3 ("Input poly_id, speed, color.\n", id_name, speed_name,
               color_name);
         Animate (file_name, id_name, speed_name, color_name, &func_strp);
         printf ("Animate RETURNs --> %s %s %s\n", func_strp, sp[0], sp[1]);
      }
      if (strcmp (op_name, "upd_attr_val") == 0)
      {
         Prompt3 ("Input attrname, color and value.\n", attr_name, color_name,
               val_name);
         UpdAttrVal (file_name, attr_name, color_name, val_name, &func_strp);
         printf ("UpdAttrVal RETURNs --> %s %s %s\n", func_strp, sp[0], sp[1]);
      }

      MainLoop (op_name, file_name, &func_strp,
            &sp[0], &sp[1], &sp[2], &sp[3], &sp[4], &sp[5]);
/*    printf ("RETURN --> %s ", func_strp); */
/*    for (i = 0; i < 6; i++) */
/*       if (strcmp (sp[i], "") != 0) */
/*          printf ("%s ", sp[i]); */
/*       else */
/*          break; */
/*    printf ("\n"); */
   }
   exit (0);
}
