.\"@(#)$Header: /n/kona/u/tangram/u/william/X11/TGIF/RCS/tgif.man,v 1.4 90/05/17 09:21:26 william Exp $
.TH TGIF 1 "Version 1.1" "Tgif"
.SH NAME
\fItgif\fR \- Xlib based 2-D drawing facility under X11.  Also supports
hierarchical construction of drawings.
.SH SYNOPSIS
.B tgif
[\fB=Geometry\fR] 
[\fIfile\fR]
.SH DESCRIPTION
\fITgif\fR is an interactive drawing tool that allows the user to draw and
manipulate objects in the X Window System.
The command line argument \fIfile\fR
specifies a file of objects to be initially edited by tgif.
Tgif is purely based on \fIXlib\fR.
It is tested under X11-R3 and X11-R4, and
it requires a 3 button mouse.
.PP
Primitive objects supported by tgif
are rectanges, ovals, polylines, polygons, open-splines, closed-splines,
and text.  Objects can be grouped together to form a \fIgrouped\fR object.
A grouped object can be made into an \fIicon\fR object or a
\fIsymbol\fR object through user commands.  (Grouped, icon, and symbol
objects are also refered to as \fIcomplex\fR objects.)
.PP
Tgif objects are stored in two types of files.  A file with a
.I \.obj
extension (refered to as an \fIobject\fR file)
is a file of objects, and a file with a
.I \.sym
extension (refered to as a \fIsymbol\fR file)
specifies a ``building-block'' object.
A building-block object consists of the
\fIrepresentation\fR part and the \fIdefinition\fR
part of the object.
Tgif supports the ``bottom-up'' construction of hierarchical
drawings by providing the capability to ``instantiate'' a
building-block object in a drawing.  Tgif also supports the ``top-down''
specification of drawings by allowing the user to make any
complex object the \fIrepresentation\fR
of an un-specified subsystem.  Both types of files are stored in the
form of Prolog facts.  Prolog code can be written to interpret
the drawings!  (It is left to the user to produce this code.
See \fItgif.pl\fR for hints.)
.PP
\fIAttributes\fR can be attached to polyline, open-spline, and complex
objects.
Attributes specified in the representation part of a
building-block object are non-detachable, when such an object is instantiated.
See \fBATTRIBUTES\fR section for details.
.PP
The output of tgif is in PostScript(TM) form.  Normally, the output
is printed to /tmp/DRAW.PS and that file is piped to lpr.
A mode within tgif allows the printout to go to a file with a
.I \.ps
extension.  This file can be included in a LaTeX document with the
\fIpsfile\fR construct; this will be discussed later.
.SH GRAPHICAL OBJECTS
An object in an \fIobject\fR file can be a primitive object, a grouped
object, or an \fIicon\fR object.
A \fIsymbol\fR file is an object file with exactly one \fIsymbol\fR
object.  (Recall that a symbol file specifies a building-block
object.)  The symbol object in a symbol file is the representation
part of the building-block object, and the rest of the
symbol file is the definition
part of the building-block object.  The symbol object is highlighted
with a dashed outline to distinguished it from the rest of
the objects.  When a building-block object is instantiated,
the symbol part of the file is copied into the graphics editor and becomes
the icon for the building-block object.
.PP
All objects in tgif can be moved, duplicated, deleted, rotated, 
and flipped.  (However, flipping text objects horizontally will
cause the text justification to change, and flipping text objects
vertically will usually cause the text object to move.)
All objects except text and icon objects can be stretched
(scaled).
.PP
Tgif supports 20 fill patterns, 20 pen patterns, 7 line widths, 4 line
styles (plain, head arrow, tail arrow, double arrows) for
polyline and open-splines, 3 types of text justifications, 4 text
styles (roman, itatlic, bold, bold-italic), 6 text sizes
(8, 10, 12, 14, 18, 24), 5 fonts (Times, Courier,
Helvetica, New-Century-Schoolbook, Symbol), and 10 colors (magenta,
red, green, blue, yellow, pink, cyan, cadet-blue, white, black).
Only right-angle rotations are supported.
All commands in tgif can either be activated by a
pop-up menu or by typing an appropriate
non-alphanumeric key.
.SH TGIF SUBWINDOWS
The tgif windows are described below.
.TP
.I Top Window
Displays the name of the file tgif is looking at.  Mouse clicks
and key presses have no effect.
.TP
.I Message Window
This is right under the top window on the left.
It displays tgif messages.  Mouse clicks and key presses have no effect.
.TP
.I Panel Window
This is the window to the right of the message window.
It displays the current choice (in top/bottom, left/right order) of the
drawing mode, color, horizontal alignment, vertical alignment,
text justification, font and text rotation, line width, line style, print mode,
poly or spline, fill pattern, and pen pattern.
Key presses have no effect.
.PP
.RS
Left mouse button advances a particular choice; right mouse button
advances in the reverse direction, and the middle button generates a pop-up
menu to set a particular choice.  If there are objects selected in the
canvas window, then the action of the mouse will cause the selected
objects to change accordingly to the newly selected choice; note that in this
case, the current choice won't change if the middle button
is used; also, icon objects
will not change because they should be thought of as ``bitmaps''.
.RE
.TP
.I Canvas Window
This is the drawing area.  Left mouse button selects, moves, stretches,
and reshapes objects.
Holding down the shift key and clicking the left mouse
on an object which is not currently selected will add the
object to the list of already selected objects.  The same
action applied to an object which is already selected will cause
it to be de-selected.
When the drawing mode is set to
text, clicking left mouse button causes selected text to go into edit mode.
In the text edit mode, clicking the middle mouse button highlights sub-strings
of the text.
Right mouse button always generates the main
tgif pop-up menu.  Holding down the shift key and clicking the right
mouse button will change the drawing mode to \fIselect\fR (clicking
or draging left mouse button will select objects).
Non-alphanumeric key presses are treated as tgif commands, and their
bindings are summarized in the following section.
.TP
.I Scrollbars
Only the left mouse button has effect in the scrollbar windows.
Clicking the left mouse button in the arrow portion of a scrollbar
window causes the canvas window to scroll a small distance on the page,
and clicking in the main area of the scrollbar window causes the
page to scroll to the specified location from the
top or the left of the page.
.TP
.I Rulers
.br
They track the mouse location.
Mouse clicks and key presses have no effect.
.SH NON-ALPHANUMERIC KEY BINDINGS
We use ``^'' for the control key and ``#'' for the meta key in the following
description.
.PP
.DS
  ^A	select all\br
  ^B	send selected objects to the back\br
  ^C	change directories\br
  ^D	duplicate selected objects\br
  ^F	send selected objects to the front\br
  ^G	group selected objects\br
  ^I	instantiate a building-block object\br
  ^K	return to a higher level and close the symbol file (reverse of ^V)\br
  ^L	align selected objects\br
  ^N	open a new un-named object file\br
  ^O	open an object file to edit\br
  ^P	print the current page\br
  ^Q	quit tgif\br
  ^R	redraw the page\br
  ^S	save the current object or symbol file\br
  ^T	align selected objects to the grid\br
  ^U	ungroup selected objects\br
  ^V	edit the definition of a building-block object
	(selected object just be an icon object)\br
  ^W	change the drawing mode to text\br
  ^X	delete all selected objects\br
  ^Z	escape to Prolog\br
\br
  #A	attach selected attributes to the selected complex object\br
  #B	escape to Prolog\br
  #C	rotate selected objects counter-clockwise\br
  #D	decrement grid size\br
  #E	send a token on a selected polyline\br
  #F	flash the selected polyline\br
  #G	show/un-show grid points\br
  #H	flip the selected object horizontally\br
  #I	increment the grid size\br
  #J	hide attribute names on the selected objects\br
  #L	give the line style and line width pop-up menu\br
  #M	move the attributes of a selected object\br
  #N	show all attribute names of the selected objects\br
  #O	zoom out\br
  #P	import a file into the current file\br
  #Q	change the drawing mode to polyline/open-spline\br
  #R	change the drawing mode to rectangle\br
  #S	escapt to Prolog\br
  #T	detach the attributes of the selected objects\br
  #U	undo the previous delete operation\br
  #V	flip the selected object vertically\br
  #W	rotate the selected objects clockwise\br
  #X	escape to Prolog\br
  #Y	escape to Prolog\br
  #Z	zoom in\br
  #0	change the font size to 8\br
  #1	change the font size to 10\br
  #2	change the font size to 12\br
  #3	change the font size to 14\br
  #4	change the font size to 18\br
  #5	change the font size to 24\br
\br
 ^#B	change the text style to bold\br
 ^#C	change the text justification to center justified\br
 ^#G	toggle snapping to the grid points\br
 ^#I	make the selected complex object iconic\br
 ^#J	make the selected icon object a grouped object\br
 ^#L	change the text justification to left justified\br
 ^#M	make the selected complex object symbolic\br
 ^#N	make the selected symbolic object a grouped object\br
 ^#O	change the text style to roman\br
 ^#P	change the text style to bold-italic\br
 ^#Q	change the drawing mode to polygon/closed-spline\br
 ^#R	change the text justification to right justified\br
 ^#S	save the file under a new name\br
 ^#T	change the text style to italic\br
 ^#V	change the drawing mode to oval\br
.DE
.br
.SH ATTRIBUTES
Attributes are text strings of the form \fIname=value\fR which are attached
to polyline, open-spline, grouped, symbol, or icon objects.
Attributes can be attached and detached from the above mentioned objects
except for the following case:
.IP
Attributes of a symbol object in a building-block object file can not
be detached when the building-block object is instantiated.
These attributes are considered to be the ``inherited'' attributes
of the icon object.
.PP
The user has control over which part of an attribute is displayed.
An entire attribute can be made invisible, or only its name
can be made invisible (accomplished through the #M command).
.SH HOW TO MAKE A BUILDING-BLOCK OBJECT (SYMBOL FILE)
Here are the steps for defining a building-block object, to be used
in a hierarchical design.
.IP 1)
Draw the representation part of the building-block object.  Group everything
together.  Select this grouped object.
.IP 2)
Pop-up the main menu with the right mouse button; select ``Special''.
Select ``MakeSymbolic'' from the next pop-up menu.
The selected object becomes a symbol and gets a dashed boundary.
.IP 3)
Type in attributes as individual text strings.  Select the
symbol object and all the
text strgings to be attached to the symbol.  Type #A (for \fIAttach\fR)
to attach attributes to the symbol.
.IP 4)
Build the definition part of the building-block object.  Look at the
``flip-flop.sym'' file for an example.  To look at that file, first,
instantiate a ``flip-flop'' by typing ^I (for \fIInstantialte\fR).
Select the flip-flop from
the pop-up window; place the flip-flop; select the flip-flop and
type ^V (for \fIPush\fR) to see the symbol file.
.IP 5)
Save and name the file.
.SH LATEX FIGURE FORMATS
Here we show how to make a figure for a LaTeX file.
.PP
Before printing a file in the \fI.ps\fR format, center the picture
on the page (e.g., the width of a portrait style page is 7.5 inch, so the
center of the page is at the 3.75 inch mark),
and make the top object on the page as close to
the top of the page as possible.
Select LaTeX format in the panel window (click the left mouse button
in the laser printer icon),
then print in the LaTeX format.
For example, if the file name is ``an-sr-flip-flop.obj'', the LaTeX figure
file generated will be named ``an-sr-flip-flop.ps''.  This file can be
included in a LaTeX document as follows,
.PP
.DS I
\\begin{figure*}[htb]
.br
\\special{psfile="an-sr-flip-flop.ps" hoffset=-40}
.br
\\rule{0in}{1.15in}
.br
\\caption{An SR flip-flop.  \\label{fig:an-sr-flip-flop}}
.br
\\end{figure*}
.br
.DE
.br
.PP
The \\rule{0in}{1.15in} above specifies an invisible box of 1.15 inches
high, which is the total height of the picture in an-sr-flip-flop.

Notice that the psfile special construct is used.  Encapsulated
PostScript format is not supported.  Also, \fItgif2ps\fR is
used to generate the \fI.ps\fR file, so it should be
installed (see the man pages on tgif2ps,
which is included in the tgif distribution).
.SH X DEFAULTS
.TP
.I Tgif*Geometry: WIDTHxHEIGHT+X+Y
.TP
.I Tgif*IconGeometry: +X+Y
.TP
.I Tgif*BorderColor: COLORSTRING
.TP
.I Tgif*Color#: COLORSTRING
This specified the correspondance between the color number and a color.
.TP
.I Tgif*MaxColors: NUMBER
This specified the maximum number of colors.  Color0 through ColorMax,
where Max is NUMBER-1 must all exist in .Xdefaults.
.TP
.I Tgif*DefaultColorIndex: NUMBER
This specified the default color index if certain color can not be found.
Default is 0.
.SH ENVIRONMENT
.TP
.I TGIFPATH
This environment variable should be set such that the files, mentioned in the
\fBFILES\fR section below, can be found.
.TP
.I TGIFICON
This environment variable should be set to the name of the object
file to be displayed when tgif is iconified.  By default, it is
set to ``tgificon''.
If it starts with a / character, absolute path is used; otherwise,
the icon file is assumed to be $TGIFPATH/$TGIFICON.
.SH FILES
$TGIFPATH/tgificon.obj
.br
.PP
The following files contain PostScript instructions.
.br
.DS I
$TGIFPATH/.psmac
.br
$TGIFPATH/.port, $TGIFPATH/.hiport, $TGIFPATH/.slideport
.br
$TGIFPATH/.land, $TGIFPATH/.hiland, $TGIFPATH/.slideland
.br
.DE
.SH SEE ALSO
\fBlatex\fR(1L), \fBlpr\fR(1), \fBenv\fR(1), \fBX\fR(1), \fBtgif2ps\fR(1)
.SH BUGS
When any of the ``escape to Prolog'' commands are accidentally
executed, just type a return key in the window where tgif is started
to resume tgif.
.PP
The directory where tgif is started is considerd the root
directory of the tgif session.  The user is not allowed to
change directory beyond the root.
.PP
Text does not have a background fill pattern.
.PP
Text can not be edited while zoomed out.
.SH COPYRIGHT
Please see the ``Copyright'' file for details on the copyrights.
.SH AUTHOR
William Chia-Wei Cheng (william@cs.ucla.edu)
